org.apache.lucene.queryParser

## Class MultiFieldQueryParser

- java.lang.Object
- - org.apache.lucene.queryParser.QueryParser
  - - org.apache.lucene.queryParser.MultiFieldQueryParser

- All Implemented Interfaces:
    QueryParserConstants

      public class MultiFieldQueryParser
      extends QueryParser

  A QueryParser which constructs queries to search multiple fields.
  Version:
    $Revision: 829134 $

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.queryParser.QueryParser

      `QueryParser.Operator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Map` | `boosts`
    `protected java.lang.String[]` | `fields`

    - ### Fields inherited from class org.apache.lucene.queryParser.QueryParser

      `AND_OPERATOR, jj_nt, OR_OPERATOR, token, token_source`

    - ### Fields inherited from interface org.apache.lucene.queryParser.QueryParserConstants

      `_ESCAPED_CHAR, _NUM_CHAR, _QUOTED_CHAR, _TERM_CHAR, _TERM_START_CHAR, _WHITESPACE, AND, Boost, CARAT, COLON, DEFAULT, EOF, FUZZY_SLOP, LPAREN, MINUS, NOT, NUMBER, OR, PLUS, PREFIXTERM, QUOTED, RangeEx, RANGEEX_END, RANGEEX_GOOP, RANGEEX_QUOTED, RANGEEX_START, RANGEEX_TO, RangeIn, RANGEIN_END, RANGEIN_GOOP, RANGEIN_QUOTED, RANGEIN_START, RANGEIN_TO, RPAREN, STAR, TERM, tokenImage, WILDTERM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiFieldQueryParser(java.lang.String[] fields, Analyzer analyzer)` Deprecated. Please use `MultiFieldQueryParser(Version, String[], Analyzer)` instead
    `MultiFieldQueryParser(java.lang.String[] fields, Analyzer analyzer, java.util.Map boosts)` Deprecated. Please use `MultiFieldQueryParser(Version, String[], Analyzer, Map)` instead
    `MultiFieldQueryParser(Version matchVersion, java.lang.String[] fields, Analyzer analyzer)` Creates a MultiFieldQueryParser.
    `MultiFieldQueryParser(Version matchVersion, java.lang.String[] fields, Analyzer analyzer, java.util.Map boosts)` Creates a MultiFieldQueryParser.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Query` | `getFieldQuery(java.lang.String field, java.lang.String queryText)`
    `protected Query` | `getFieldQuery(java.lang.String field, java.lang.String queryText, int slop)` Base implementation delegates to `QueryParser.getFieldQuery(String,String)`.
    `protected Query` | `getFuzzyQuery(java.lang.String field, java.lang.String termStr, float minSimilarity)` Factory method for generating a query (similar to `QueryParser.getWildcardQuery(java.lang.String, java.lang.String)`).
    `protected Query` | `getPrefixQuery(java.lang.String field, java.lang.String termStr)` Factory method for generating a query (similar to `QueryParser.getWildcardQuery(java.lang.String, java.lang.String)`).
    `protected Query` | `getRangeQuery(java.lang.String field, java.lang.String part1, java.lang.String part2, boolean inclusive)`
    `protected Query` | `getWildcardQuery(java.lang.String field, java.lang.String termStr)` Factory method for generating a query.
    `static Query` | `parse(java.lang.String[] queries, java.lang.String[] fields, Analyzer analyzer)` Deprecated. Use `parse(Version,String[],String[],Analyzer)` instead
    `static Query` | `parse(java.lang.String[] queries, java.lang.String[] fields, BooleanClause.Occur[] flags, Analyzer analyzer)` Deprecated. Used `parse(Version, String[], String[], BooleanClause.Occur[], Analyzer)` instead
    `static Query` | `parse(java.lang.String query, java.lang.String[] fields, BooleanClause.Occur[] flags, Analyzer analyzer)` Deprecated. Use `parse(Version, String, String[], BooleanClause.Occur[], Analyzer)` instead
    `static Query` | `parse(Version matchVersion, java.lang.String[] queries, java.lang.String[] fields, Analyzer analyzer)` Parses a query which searches on the fields specified.
    `static Query` | `parse(Version matchVersion, java.lang.String[] queries, java.lang.String[] fields, BooleanClause.Occur[] flags, Analyzer analyzer)` Parses a query, searching on the fields specified.
    `static Query` | `parse(Version matchVersion, java.lang.String query, java.lang.String[] fields, BooleanClause.Occur[] flags, Analyzer analyzer)` Parses a query, searching on the fields specified.

    - ### Methods inherited from class org.apache.lucene.queryParser.QueryParser

      `addClause, addClause, Clause, Conjunction, disable_tracing, enable_tracing, escape, generateParseException, getAllowLeadingWildcard, getAnalyzer, getBooleanQuery, getBooleanQuery, getBooleanQuery, getBooleanQuery, getDateResolution, getDefaultOperator, getEnablePositionIncrements, getField, getFuzzyMinSim, getFuzzyPrefixLength, getLocale, getLowercaseExpandedTerms, getMultiTermRewriteMethod, getNextToken, getPhraseSlop, getRangeCollator, getToken, getUseOldRangeQuery, main, Modifiers, newBooleanClause, newBooleanQuery, newFuzzyQuery, newMatchAllDocsQuery, newMultiPhraseQuery, newPhraseQuery, newPrefixQuery, newRangeQuery, newTermQuery, newWildcardQuery, parse, Query, ReInit, ReInit, setAllowLeadingWildcard, setDateResolution, setDateResolution, setDefaultOperator, setEnablePositionIncrements, setFuzzyMinSim, setFuzzyPrefixLength, setLocale, setLowercaseExpandedTerms, setMultiTermRewriteMethod, setPhraseSlop, setRangeCollator, setUseOldRangeQuery, Term, TopLevelQuery`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### fields

          protected java.lang.String[] fields

    - #### boosts

          protected java.util.Map boosts

  - ### Constructor Detail

    - #### MultiFieldQueryParser

          public MultiFieldQueryParser(java.lang.String[] fields,
                                       Analyzer analyzer,
                                       java.util.Map boosts)

      Deprecated. Please use `MultiFieldQueryParser(Version, String[], Analyzer, Map)` instead
      Creates a MultiFieldQueryParser. Allows passing of a map with term to Boost, and the boost to apply to each term.

      It will, when parse(String query) is called, construct a query like this (assuming the query consists of two terms and you specify the two fields `title` and `body`):

      `(title:term1 body:term1) (title:term2 body:term2)`

      When setDefaultOperator(AND_OPERATOR) is set, the result will be:

      `+(title:term1 body:term1) +(title:term2 body:term2)`

      When you pass a boost (title=>5 body=>10) you can get

      `+(title:term1^5.0 body:term1^10.0) +(title:term2^5.0 body:term2^10.0)`

      In other words, all the query's terms must appear, but it doesn't matter in what fields they appear.

    - #### MultiFieldQueryParser

          public MultiFieldQueryParser(Version matchVersion,
                                       java.lang.String[] fields,
                                       Analyzer analyzer,
                                       java.util.Map boosts)

      Creates a MultiFieldQueryParser. Allows passing of a map with term to Boost, and the boost to apply to each term.

      It will, when parse(String query) is called, construct a query like this (assuming the query consists of two terms and you specify the two fields `title` and `body`):

      `(title:term1 body:term1) (title:term2 body:term2)`

      When setDefaultOperator(AND_OPERATOR) is set, the result will be:

      `+(title:term1 body:term1) +(title:term2 body:term2)`

      When you pass a boost (title=>5 body=>10) you can get

      `+(title:term1^5.0 body:term1^10.0) +(title:term2^5.0 body:term2^10.0)`

      In other words, all the query's terms must appear, but it doesn't matter in what fields they appear.

    - #### MultiFieldQueryParser

          public MultiFieldQueryParser(java.lang.String[] fields,
                                       Analyzer analyzer)

      Deprecated. Please use `MultiFieldQueryParser(Version, String[], Analyzer)` instead
      Creates a MultiFieldQueryParser.

      It will, when parse(String query) is called, construct a query like this (assuming the query consists of two terms and you specify the two fields `title` and `body`):

      `(title:term1 body:term1) (title:term2 body:term2)`

      When setDefaultOperator(AND_OPERATOR) is set, the result will be:

      `+(title:term1 body:term1) +(title:term2 body:term2)`

      In other words, all the query's terms must appear, but it doesn't matter in what fields they appear.

    - #### MultiFieldQueryParser

          public MultiFieldQueryParser(Version matchVersion,
                                       java.lang.String[] fields,
                                       Analyzer analyzer)

      Creates a MultiFieldQueryParser.

      It will, when parse(String query) is called, construct a query like this (assuming the query consists of two terms and you specify the two fields `title` and `body`):

      `(title:term1 body:term1) (title:term2 body:term2)`

      When setDefaultOperator(AND_OPERATOR) is set, the result will be:

      `+(title:term1 body:term1) +(title:term2 body:term2)`

      In other words, all the query's terms must appear, but it doesn't matter in what fields they appear.

  - ### Method Detail

    - #### getFieldQuery

          protected Query getFieldQuery(java.lang.String field,
                                        java.lang.String queryText,
                                        int slop)
                                 throws ParseException

      Description copied from class: `QueryParser`
      Base implementation delegates to `QueryParser.getFieldQuery(String,String)`. This method may be overridden, for example, to return a SpanNearQuery instead of a PhraseQuery.
      Overrides:
        `getFieldQuery` in class `QueryParser`
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getFieldQuery

          protected Query getFieldQuery(java.lang.String field,
                                        java.lang.String queryText)
                                 throws ParseException

      Overrides:
        `getFieldQuery` in class `QueryParser`
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getFuzzyQuery

          protected Query getFuzzyQuery(java.lang.String field,
                                        java.lang.String termStr,
                                        float minSimilarity)
                                 throws ParseException

      Description copied from class: `QueryParser`
      Factory method for generating a query (similar to `QueryParser.getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that has the fuzzy suffix (~) appended.
      Overrides:
        `getFuzzyQuery` in class `QueryParser`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token to use for building term for the query
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getPrefixQuery

          protected Query getPrefixQuery(java.lang.String field,
                                         java.lang.String termStr)
                                  throws ParseException

      Description copied from class: `QueryParser`
      Factory method for generating a query (similar to `QueryParser.getWildcardQuery(java.lang.String, java.lang.String)`). Called when parser parses an input term token that uses prefix notation; that is, contains a single '*' wildcard character as its last character. Since this is a special case of generic wildcard term, and such a query can be optimized easily, this usually results in a different query object.

      Depending on settings, a prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

      Can be overridden by extending classes, to provide custom handling for wild card queries, which may be necessary due to missing analyzer calls.

      Overrides:
        `getPrefixQuery` in class `QueryParser`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token to use for building term for the query (without trailing '*' character!)
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getWildcardQuery

          protected Query getWildcardQuery(java.lang.String field,
                                           java.lang.String termStr)
                                    throws ParseException

      Description copied from class: `QueryParser`
      Factory method for generating a query. Called when parser parses an input term token that contains one or more wildcard characters (? and *), but is not a prefix term token (one that has just a single * character at the end)

      Depending on settings, prefix term may be lower-cased automatically. It will not go through the default Analyzer, however, since normal Analyzers are unlikely to work properly with wildcard templates.

      Can be overridden by extending classes, to provide custom handling for wildcard queries, which may be necessary due to missing analyzer calls.

      Overrides:
        `getWildcardQuery` in class `QueryParser`
      Parameters:
        `field` - Name of the field query will use.
        `termStr` - Term token that contains one or more wild card characters (? or *), but is not simple prefix term
      Returns:
        Resulting `Query` built for the term
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### getRangeQuery

          protected Query getRangeQuery(java.lang.String field,
                                        java.lang.String part1,
                                        java.lang.String part2,
                                        boolean inclusive)
                                 throws ParseException

      Overrides:
        `getRangeQuery` in class `QueryParser`
      Throws:
        `ParseException` - throw in overridden method to disallow

    - #### parse

          public static Query parse(java.lang.String[] queries,
                                    java.lang.String[] fields,
                                    Analyzer analyzer)
                             throws ParseException

      Deprecated. Use `parse(Version,String[],String[],Analyzer)` instead
      Parses a query which searches on the fields specified.

      If x fields are specified, this effectively constructs:

           (field1:query1) (field2:query2) (field3:query3)...(fieldx:queryx)

      Parameters:
        `queries` - Queries strings to parse
        `fields` - Fields to search on
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `java.lang.IllegalArgumentException` - if the length of the queries array differs from the length of the fields array

    - #### parse

          public static Query parse(Version matchVersion,
                                    java.lang.String[] queries,
                                    java.lang.String[] fields,
                                    Analyzer analyzer)
                             throws ParseException

      Parses a query which searches on the fields specified.

      If x fields are specified, this effectively constructs:

           (field1:query1) (field2:query2) (field3:query3)...(fieldx:queryx)

      Parameters:
        `matchVersion` - Lucene version to match; this is passed through to QueryParser.
        `queries` - Queries strings to parse
        `fields` - Fields to search on
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `java.lang.IllegalArgumentException` - if the length of the queries array differs from the length of the fields array

    - #### parse

          public static Query parse(java.lang.String query,
                                    java.lang.String[] fields,
                                    BooleanClause.Occur[] flags,
                                    Analyzer analyzer)
                             throws ParseException

      Deprecated. Use `parse(Version, String, String[], BooleanClause.Occur[], Analyzer)` instead
      Parses a query, searching on the fields specified. Use this if you need to specify certain fields as required, and others as prohibited.

           Usage:

           String[] fields = {"filename", "contents", "description"};
           BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
                          BooleanClause.Occur.MUST,
                          BooleanClause.Occur.MUST_NOT};
           MultiFieldQueryParser.parse("query", fields, flags, analyzer);

      The code above would construct a query:

           (filename:query) +(contents:query) -(description:query)

      Parameters:
        `query` - Query string to parse
        `fields` - Fields to search on
        `flags` - Flags describing the fields
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `java.lang.IllegalArgumentException` - if the length of the fields array differs from the length of the flags array

    - #### parse

          public static Query parse(Version matchVersion,
                                    java.lang.String query,
                                    java.lang.String[] fields,
                                    BooleanClause.Occur[] flags,
                                    Analyzer analyzer)
                             throws ParseException

      Parses a query, searching on the fields specified. Use this if you need to specify certain fields as required, and others as prohibited.

           Usage:

           String[] fields = {"filename", "contents", "description"};
           BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
                          BooleanClause.Occur.MUST,
                          BooleanClause.Occur.MUST_NOT};
           MultiFieldQueryParser.parse("query", fields, flags, analyzer);

      The code above would construct a query:

           (filename:query) +(contents:query) -(description:query)

      Parameters:
        `matchVersion` - Lucene version to match; this is passed through to QueryParser.
        `query` - Query string to parse
        `fields` - Fields to search on
        `flags` - Flags describing the fields
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `java.lang.IllegalArgumentException` - if the length of the fields array differs from the length of the flags array

    - #### parse

          public static Query parse(java.lang.String[] queries,
                                    java.lang.String[] fields,
                                    BooleanClause.Occur[] flags,
                                    Analyzer analyzer)
                             throws ParseException

      Deprecated. Used `parse(Version, String[], String[], BooleanClause.Occur[], Analyzer)` instead
      Parses a query, searching on the fields specified. Use this if you need to specify certain fields as required, and others as prohibited.

           Usage:

           String[] query = {"query1", "query2", "query3"};
           String[] fields = {"filename", "contents", "description"};
           BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
                          BooleanClause.Occur.MUST,
                          BooleanClause.Occur.MUST_NOT};
           MultiFieldQueryParser.parse(query, fields, flags, analyzer);

      The code above would construct a query:

           (filename:query1) +(contents:query2) -(description:query3)

      Parameters:
        `queries` - Queries string to parse
        `fields` - Fields to search on
        `flags` - Flags describing the fields
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `java.lang.IllegalArgumentException` - if the length of the queries, fields, and flags array differ

    - #### parse

          public static Query parse(Version matchVersion,
                                    java.lang.String[] queries,
                                    java.lang.String[] fields,
                                    BooleanClause.Occur[] flags,
                                    Analyzer analyzer)
                             throws ParseException

      Parses a query, searching on the fields specified. Use this if you need to specify certain fields as required, and others as prohibited.

           Usage:

           String[] query = {"query1", "query2", "query3"};
           String[] fields = {"filename", "contents", "description"};
           BooleanClause.Occur[] flags = {BooleanClause.Occur.SHOULD,
                          BooleanClause.Occur.MUST,
                          BooleanClause.Occur.MUST_NOT};
           MultiFieldQueryParser.parse(query, fields, flags, analyzer);

      The code above would construct a query:

           (filename:query1) +(contents:query2) -(description:query3)

      Parameters:
        `matchVersion` - Lucene version to match; this is passed through to QueryParser.
        `queries` - Queries string to parse
        `fields` - Fields to search on
        `flags` - Flags describing the fields
        `analyzer` - Analyzer to use
      Throws:
        `ParseException` - if query parsing fails
        `java.lang.IllegalArgumentException` - if the length of the queries, fields, and flags array differ

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.